#include <config.h>
#include "gui_functions.h"
#include "xine_iface_gui.h"
#include "flxine.h"

#include <FL/filename.H>
#include <FL/x.H>

#include <stdio.h>
#include <ctype.h>
#include <string.h>

#include <xine.h>

#define MAX_EXT_BUF 256

int gui_load_dir()
{
	dirent **list;
	char *media_extensions, *s;
	char ext_buf[MAX_EXT_BUF];
	int num_files, filter, show_hidden;
	char buf[MAX_FLXINE_PATH + 255 + 1];

	media_extensions = new char[strlen(xinei->get_extensions ()) + 1];
	strcpy(media_extensions, xinei->get_extensions ());

	strncpy(buf, main_dir, MAX_FLXINE_PATH);

	fl_filename_absolute(main_dir, buf);
	gui_filename_input->value(main_dir);

	Fl_File_Sort_F *sort = fl_casealphasort;
	num_files = fl_filename_list(main_dir, &list, sort);

	filter = gui_file_filter->value();
	show_hidden = gui_file_hidden->value();

	gui_file_browser->clear();

// First directories, then files
//
	for(int i = 0; i < num_files; i++)
   {
	if(strcmp(list[i]->d_name, "./") == 0) 
  {
	list[i]->d_name[0] = 0;
	continue;
  }
	if(strcmp(list[i]->d_name, "../") == 0)
  {
	list[i]->d_name[0] = 0;

	if(strcmp(main_dir, "/") != 0)
 {
	gui_file_browser->add("..");
 }
	continue;
  }
	snprintf(buf, MAX_FLXINE_PATH + 256, "%s%s", 
		main_dir, list[i]->d_name);

	if(fl_filename_isdir(buf))
  {
	if((show_hidden == 0) && (list[i]->d_name[0] == '.') )
 {
	list[i]->d_name[0] = 0;
	continue;
 }
	gui_file_browser->add(list[i]->d_name);
	list[i]->d_name[0] = 0;
	continue;
  }
   }//for(int i = 0; i < num_files; i++)

//Now the files
//
	for(int i = 0; i < num_files; i++)
   {
	if(list[i]->d_name[0] == 0) continue;

	if((show_hidden == 0) && (list[i]->d_name[0] == '.') )
  {
	list[i]->d_name[0] = 0;
	continue;
  }

	if( !filter)
  {
	gui_file_browser->add(list[i]->d_name);
	list[i]->d_name[0] = 0;
	continue;
  }
//Test for extensions
//
	strncpy(ext_buf, fl_filename_ext(list[i]->d_name), MAX_EXT_BUF );
	s = ext_buf;
	if(*s == '.') ++s;

	if(strlen(s) > 2)
  {
	while(*s) { *s = tolower(*s); ++s; }
	s = ext_buf;
	if(*s == '.') ++s;

	if(strstr(media_extensions, s) != NULL)
 {
	gui_file_browser->add(list[i]->d_name);
	list[i]->d_name[0] = 0;

	continue;
 }
  }
	list[i]->d_name[0] = 0;

   }//for(int i = 0; i < num_files; i++)


	fl_filename_free_list(&list, num_files);

	delete [] media_extensions;

	return 0;
}//gui_load_dir()

int gui_select_file(const char *file)
{
/* First test to see if we selected a directory,
 * and if so we are changing to it               
*/
	if(strcmp(file, "..") == 0)
   {
	int good_sel = gui_up_dir();
	gui_load_dir();
	return good_sel;
   }

	if(file[0] == '/') *main_dir = 0;

   {//block
	char raw_path[MAX_FLXINE_PATH + 256];

	snprintf(raw_path, MAX_FLXINE_PATH + 256, "%s%s", main_dir, file);

	if(fl_filename_isdir(raw_path))
  {
	if(raw_path[strlen(raw_path) - 1] != '/')
	 strcat(raw_path, "/");

	strcpy(main_dir, raw_path);

	gui_load_dir();
  }
	else
  {
	gui_playlist_browser->clear();
	gui_playlist_browser->add(raw_path);

	current_item = 0;

	if(xinei->open(raw_path))
 {
	xinei->cd_running(false);

	xinei->play();
 }
	else
 {
	printf("%s:%d:\n\tCan not open(%s)\n",__FILE__,__LINE__,raw_path);
 }
  }
   }//block
	return 0;

}//gui_select_file() raw_path return

int
gui_up_dir()
{
	if(strcmp(main_dir, "/") != 0)
	{
/*I'm sure there is a better way to knock off the last directory... 
*/
		char *name;

		name = strrchr(main_dir, '/');
		if(name) name[0] = '\0';
		name = strrchr(main_dir, '/');
		if(name) name[1] = '\0';
	}
	return 0;
}

void gui_load_plugins()
{
	control_plugin_button_0->label(xinei->get_auto_plugin(0));
	control_plugin_button_0->tooltip(xinei->get_auto_plugin_desc(0));
	gui_playlist_plugin_button_0->label(xinei->get_auto_plugin(0));
	gui_playlist_plugin_button_0->tooltip(xinei->get_auto_plugin_desc(0));

	control_plugin_button_1->label(xinei->get_auto_plugin(1));
	control_plugin_button_1->tooltip(xinei->get_auto_plugin_desc(1));
	gui_playlist_plugin_button_1->label(xinei->get_auto_plugin(1));
	gui_playlist_plugin_button_1->tooltip(xinei->get_auto_plugin_desc(1));

	control_plugin_button_2->label(xinei->get_auto_plugin(2));
	control_plugin_button_2->tooltip(xinei->get_auto_plugin_desc(2));
	gui_playlist_plugin_button_2->label(xinei->get_auto_plugin(2));
	gui_playlist_plugin_button_2->tooltip(xinei->get_auto_plugin_desc(2));

	control_plugin_button_3->label(xinei->get_auto_plugin(3));
	control_plugin_button_3->tooltip(xinei->get_auto_plugin_desc(3));
	gui_playlist_plugin_button_3->label(xinei->get_auto_plugin(3));
	gui_playlist_plugin_button_3->tooltip(xinei->get_auto_plugin_desc(3));

	control_plugin_button_4->label(xinei->get_auto_plugin(4));
	control_plugin_button_4->tooltip(xinei->get_auto_plugin_desc(4));
	gui_playlist_plugin_button_4->label(xinei->get_auto_plugin(4));
	gui_playlist_plugin_button_4->tooltip(xinei->get_auto_plugin_desc(4));

	control_plugin_button_5->label(xinei->get_auto_plugin(5));
	control_plugin_button_5->tooltip(xinei->get_auto_plugin_desc(5));
	gui_playlist_plugin_button_5->label(xinei->get_auto_plugin(5));
	gui_playlist_plugin_button_5->tooltip(xinei->get_auto_plugin_desc(5));

	control_plugin_button_6->label(xinei->get_auto_plugin(6));
	control_plugin_button_6->tooltip(xinei->get_auto_plugin_desc(6));
	gui_playlist_plugin_button_6->label(xinei->get_auto_plugin(6));
	gui_playlist_plugin_button_6->tooltip(xinei->get_auto_plugin_desc(6));

	int i;

	const char *const *audio_drivers = xinei->get_audio_drivers ();

	gui_audio_driver_choice->add("auto");

	for(i = 0; audio_drivers[i] != NULL; i++)
   {
	gui_audio_driver_choice->add(audio_drivers[i]);

	if(xinei->get_current_audio_driver() == NULL)
		gui_audio_driver_choice->value(0);
	else 
	if(strcmp(audio_drivers[i], xinei->get_current_audio_driver()) == 0)
		gui_audio_driver_choice->value(i);
   }

	const char *const *video_drivers = xinei->get_video_drivers();

	gui_vid_driver_choice->add("auto");

	for(i = 0; video_drivers[i] != NULL; i++)
   {
	gui_vid_driver_choice->add(video_drivers[i]);
   }

	const char *const *post_plugins =
		xinei->get_post_plugins(XINE_POST_TYPE_AUDIO_VISUALIZATION);

	for(i = 0; post_plugins[i] != NULL; i++)
   {
	gui_vis_plugin_choice->add(post_plugins[i]);
   }
	gui_vid_deinterlace->add("none");
	gui_vid_deinterlace->add("bob");
	gui_vid_deinterlace->add("weave");
	gui_vid_deinterlace->add("greedy");
	gui_vid_deinterlace->add("onefield");
	gui_vid_deinterlace->add("onefield_xv");
	gui_vid_deinterlace->add("linearblend");
}

void gui_apply_config()
{
	int reinit_xine=0;
	const char *cs;

	xine_cfg_entry_t vis_entry;

	xinei->config_lookup("flxine.vis_post_plugin",&vis_entry);

	cs = gui_vis_plugin_choice->text();

	if( !cs) return;

	vis_entry.str_value = strdup(cs);

	xinei->config_update(&vis_entry);
	
	xinei->config_lookup("flxine.vis_enable",&vis_entry);

	vis_entry.num_value = gui_vis_plugin_enable->value();
	xinei->config_update(&vis_entry);
	
	if(gui_vis_plugin_enable->value ())
   {
	if(gui_vis_plugin_choice->text()
	&& strcmp(xinei->get_vis(), gui_vis_plugin_choice->text ()))
  {
	xinei->use_vis(gui_vis_plugin_enable->value (),
		gui_vis_plugin_choice->text ());
  }
   }
	else
	 xinei->use_vis(false, NULL);

	if(gui_audio_driver_choice->changed())
   {
	xine_cfg_entry_t audio_entry;
	xinei->config_lookup("flxine.audio_driver", &audio_entry);

	cs = gui_audio_driver_choice->text();

	if(!cs) return;

	audio_entry.str_value = strdup(cs);

	xinei->config_update (&audio_entry);	

	reinit_xine = 1;
   }
	
	if(gui_vid_driver_choice->changed())
   {
	xine_cfg_entry_t video_entry;

	xinei->config_lookup("flxine.video_driver", &video_entry);

	cs = gui_vid_driver_choice->text();

	if(!cs) return;

	video_entry.str_value = strdup(cs);

	xinei->config_update (&video_entry);	

	reinit_xine = 1;
   }
	
	if(reinit_xine)
	 gui_refresh_drivers();
}

void gui_refresh_drivers()
{
	int pos, time, len, speed = 0;
	const char *mrl = xinei->mrl();

	if(mrl != NULL)
   {
	speed = xinei->get_speed();
	xinei->get_stream_time(&pos,&time, &len);		
   }
	xinei->stop();
	xinei->deinit();

	xinei->init(gui_vid_driver_choice->text(),
		gui_audio_driver_choice->text());

	if(mrl != NULL)
   {
	if(xinei->open(mrl))
  {
	xinei->play();
	xinei->set_position(pos);
	xinei->set_speed(speed);
  }
   }
}

void gui_load_settings()
{
	int i;
	xine_cfg_entry_t entry;

	if( xinei->config_lookup("flxine.video_driver", &entry) ==0 )
   {
	xinei->config_new_string("flxine.video_driver",
			  "auto",
			  "Video Driver",
			  "Video driver that xine engine should use",
			  20, NULL, NULL);
   }
	xinei->config_lookup("flxine.video_driver", &entry);

	for(i=0; i<gui_vid_driver_choice->size()-1; i++)
   {
	if( strcmp(gui_vid_driver_choice->text(i),entry.str_value)==0 )
			gui_vid_driver_choice->value(i);
   }
	
	if(!xinei->config_lookup("flxine.audio_driver", &entry))
   {
	xinei->config_new_string("flxine.audio_driver",
			  "auto",
			  "Audio Driver",
			  "Audio driver that xine engine should use",
			  20, NULL, NULL);
   }
	xinei->config_lookup("flxine.audio_driver", &entry);

	if(!xinei->config_lookup("flxine.vis_post_plugin", &entry))
		xinei->config_new_string ("flxine.vis_post_plugin",
			"",
			"Visualization Plugin",
			"Plugin to use when some visualization is desired "
			"for streams with no video",
			10, NULL, NULL);

	xinei->config_lookup("flxine.vis_post_plugin", &entry);

	for(i=0; i<gui_vis_plugin_choice->size()-1; i++)		
		if( strcmp(gui_vis_plugin_choice->text(i),entry.str_value)==0)			
			gui_vis_plugin_choice->value(i);
	
	if(!xinei->config_lookup("flxine.vis_enable", &entry))
		xinei->config_new_bool("flxine.vis_enable",
			0,
			"Enable Visualization Plugin",
			"Do you want to display a visualization where "
			"there is no video to display?",
			10, NULL, NULL);
	
}//gui_load_settings(

void gui_save_settings()
{
	xinei->config_save();
}

void playlist_add_files()
{
	char file[MAX_FLXINE_PATH + 256];

	for(int i = 0; i < gui_file_browser->size(); i++)
   {
	if(gui_file_browser->selected(i))
  {
	snprintf(file, MAX_FLXINE_PATH + 256, "%s%s", 
		main_dir, gui_file_browser->text(i));

	if( !fl_filename_isdir(file))
	 gui_playlist_browser->add(file);
  }
   }
}

void playlist_remove_selected()
{
	for(int i = 0; i <= gui_playlist_browser->size(); i++)
   {
	if(gui_playlist_browser->selected (i))
  {
	gui_playlist_browser->remove(i);

	if(current_item >= i) --current_item;

	i--;
  }
   }
}

void playlist_move_up()
{
	int position = gui_playlist_browser->value();

	if(position == 1)
   {
	gui_playlist_browser->move(gui_playlist_browser->size(), position);

	position = gui_playlist_browser->size();
   }
	else
   {
	int up = position - 1;

	gui_playlist_browser->move(position, up);
	--position;
   }

	gui_playlist_browser->deselect();
	gui_playlist_browser->select(position);
}

void playlist_move_down()
{
	int position = gui_playlist_browser->value();

	if(position == gui_playlist_browser->size())
   {
	gui_playlist_browser->move(1, position);
	position = 1;
   }
	else
   {
	int down = position + 1;

	gui_playlist_browser->move(position, down);
	++position;
   }

	gui_playlist_browser->deselect();

	gui_playlist_browser->select(position);
}

void playlist_prev()
{
	if(gui_playlist_browser->size())
   {
	if(current_item == 1)
		current_item = gui_playlist_browser->size();
	else
		--current_item;

	gui_playlist_browser->deselect();
	gui_playlist_browser->value(current_item);
	xinei->open(gui_playlist_browser->text(current_item) );
	xinei->play();
   }
}

void playlist_next()
{
	if(gui_playlist_browser->size())
   {
	if(current_item == gui_playlist_browser->size())
		current_item = 1;
	else
		++current_item;

	gui_playlist_browser->deselect();
	gui_playlist_browser->value(current_item);
	xinei->open(gui_playlist_browser->text(current_item) );

	xinei->play();
   }
}

int playlist_add_plugin(int id)
{
	const char * const *mrls = xinei->get_plugin_autoplay_mrls(id);

	if(mrls == NULL) return 0;

	for(int i = 0; mrls[i] != NULL; i++)
   {
	gui_playlist_browser->add(mrls[i]);
   }
	return 1;
}

