#include <config.h>
// generated by Fast Light User Interface Designer (fluid) version 1.0102

#include <stdlib.h>
#include <stdio.h>

#include "flxine.h"
#include "gui_functions.h"
#include "xine_iface_gui.h"

//--- if you do not define this you get a FILL_SLIDER
#define WANT_NICE_SLIDER

#define BUTTON_H 25
#define SLIDER_H 15

#define DX 5
#define DY 5

#define GUI_WINDOW_H (DY+SLIDER_H+DY+BUTTON_H+DY+BUTTON_H+DY+BUTTON_H+DY+BUTTON_H+DY+BUTTON_H+DY+BUTTON_H+DY)

//---- FORWARD

static Fl_Window *file_browser_window = NULL;
static Fl_Window *config_window = NULL;
static Fl_Window *gui_playlist_window = NULL;

Fl_Window *video_window = NULL;

Fl_Choice *gui_audio_driver_choice=(Fl_Choice *)0;

Fl_Browser *gui_playlist_browser=(Fl_Browser *)0;

Fl_Line_Dial *gui_volume_knob = NULL;
Fl_Light_Button *gui_volume_mute_button = NULL;

Fl_Box *Clock = NULL;

static Fl_Box *control_language_box, *control_subtitle_box;
static Fl_Group *control_language_group, *control_subtitle_group;

#define LANG_BUT_H 12
static int lang, sub;
static char langbuf[XINE_LANG_MAX];

void control_hide_language_and_subtitle()
{
	control_language_group->deactivate();
	control_subtitle_group->deactivate();
}

void control_reset_language_and_subtitle()
{
	control_language_group->activate();
	control_subtitle_group->activate();

	lang = sub = -1;
	strcpy(langbuf, "auto");

	xinei->cycle_audio_channel(-1);
	control_language_box->label(langbuf);

	strcpy(langbuf, "none");
	xinei->cycle_spu_channel(-1);
	control_subtitle_box->label(langbuf);
}

static void lang_up_cb(Fl_Widget *wid, void *v)
{
	xine_stream_t *stream = xinei->get_xine_stream();

	if(stream == NULL) return;

    if(lang < 7) ++lang;

	xinei->cycle_audio_channel(lang);

	if( !xine_get_audio_lang(stream, lang, langbuf))
	 sprintf(langbuf, "%d", lang);

    control_language_box->label(langbuf);
}

static void lang_down_cb(Fl_Widget *wid, void *v)
{
	xine_stream_t *stream = xinei->get_xine_stream();

	if(stream == NULL) return;

    if(lang > -2) --lang;

	xinei->cycle_audio_channel(lang);

	if( !xine_get_audio_lang(stream, lang, langbuf))
   {
	if(lang == -2)
	 strcpy(langbuf, "off");
	else
	if(lang == -1)
	 strcpy(langbuf, "auto");
	else
	 sprintf(langbuf, "%d", lang);
   }
    control_language_box->label(langbuf);
}

static void sub_up_cb(Fl_Widget *wid, void *v)
{
	xine_stream_t *stream = xinei->get_xine_stream();

	if(stream == NULL) return;

    if(sub < 31) ++sub;

	xinei->cycle_spu_channel(sub);

	if( !xine_get_spu_lang(stream, sub, langbuf))
	 sprintf(langbuf, "%d", sub);

    control_subtitle_box->label(langbuf);

}

static void sub_down_cb(Fl_Widget *wid, void *v)
{
	xine_stream_t *stream = xinei->get_xine_stream();

	if(stream == NULL) return;

    if(sub > -1) --sub;

	xinei->cycle_spu_channel(sub);

	if( !xine_get_spu_lang(stream, sub, langbuf))
   {
	if(sub == -1)
	 strcpy(langbuf, "none");
	else
	 sprintf(langbuf, "%d", sub);
   }
    control_subtitle_box->label(langbuf);

}


static void cb_gui_audio_driver_choice(Fl_Choice*, void*) 
{
  gui_audio_driver_choice->set_changed();
}

Fl_Group *gui_audio_surround_group=(Fl_Group *)0;

Fl_Light_Button *gui_audio_4speakers=(Fl_Light_Button *)0;

Fl_Light_Button *gui_audio_5speakers=(Fl_Light_Button *)0;

Fl_Light_Button *gui_audio_5_1speakers=(Fl_Light_Button *)0;

Fl_Group *gui_vid_config = NULL;

static void cb_gui_vid_config(Fl_Widget*, void*) 
{
  gui_vid_config->set_changed();
}

Fl_Choice *gui_vid_driver_choice=(Fl_Choice *)0;

static void cb_gui_vid_driver_choice(Fl_Choice*, void*) 
{
  gui_vid_driver_choice->set_changed();
}

Fl_Choice *gui_vid_deinterlace=(Fl_Choice *)0;

static void cb_gui_vid_deinterlace(Fl_Choice*, void*) 
{
  gui_vid_deinterlace->set_changed();
}

Fl_Choice *gui_vis_plugin_choice=(Fl_Choice *)0;

static void cb_gui_vis_plugin_choice(Fl_Choice*, void*) 
{
  gui_vis_plugin_choice->set_changed();
}

Fl_Round_Button *gui_vis_plugin_enable=(Fl_Round_Button *)0;

Fl_Button *gui_config_ok=(Fl_Button *)0;

static void cb_gui_config_ok(Fl_Button*, void*) 
{
  gui_apply_config();

  config_window->hide();
}

static void cb_Cancel(Fl_Button*, void*) 
{
  config_window->hide();
}

Fl_Button *gui_config_apply=(Fl_Button *)0;

static void cb_gui_config_apply(Fl_Button*, void*) 
{
  gui_apply_config();
}

Fl_Window *control_window=(Fl_Window *)0;

static void cb_control_play_button(Fl_Button*, void*) 
{
  xinei->play();
}

static void cb_control_stop_button(Fl_Button*, void*) 
{
  xinei->stop();
}

static void cb_control_next_button(Fl_Button*, void*) 
{
	if(!xinei->next())
   {
	playlist_next();
   }
}

static void cb_control_prev_button(Fl_Button*, void*) 
{
	if(!xinei->prev())
   {
	playlist_prev();
   }
}

static void cb_control_slower_button(Fl_Button*, void*) 
{
  xinei->slower();
}

static void cb_control_faster_button(Fl_Button*, void*) 
{
  xinei->faster();
}

static void cb_control_eject_button(Fl_Button*, void*) 
{
  xinei->eject();
}

static void cb_navi_left_button(Fl_Widget*, void*) 
{
  xinei->nav_left();
}

static void cb_navi_select_button(Fl_Widget*, void*) 
{
  xinei->nav_select();
}

static void cb_navi_right_button(Fl_Widget*, void*) 
{
  xinei->nav_right();
}

static void cb_navi_down_button(Fl_Widget*, void*) 
{
  xinei->nav_down();
}

static void cb_navi_up_button(Fl_Widget*, void*) 
{
  xinei->nav_up();
}

static void cb_navi_menu_button(Fl_Widget*, void*) 
{
  xinei->nav_menu1();
}

static void cb_control_config_button(Fl_Button*, void*) 
{
  if (config_window->visible() )
	config_window->hide();
  else
	config_window->show();
}

Fl_Button *control_plugin_button_0 = NULL;
Fl_Button *control_plugin_button_1 = NULL;
Fl_Button *control_plugin_button_2 = NULL;
Fl_Button *control_plugin_button_3 = NULL;
Fl_Button *control_plugin_button_4 = NULL;
Fl_Button *control_plugin_button_5 = NULL;
Fl_Button *control_plugin_button_6 = NULL;

static void cb_control_plugin_button_0(Fl_Widget*, void*)//CD 
{
	xinei->start_plugin(0);
}

static void cb_control_plugin_button_1(Fl_Widget*, void*)//DVB 
{
  xinei->start_plugin(1);
}

static void cb_control_plugin_button_2(Fl_Widget*, void*)//DVB
{
  xinei->start_plugin(2);
}

static void cb_control_plugin_button_3(Fl_Widget*, void*)//DVD
{

  xinei->start_plugin(3);
}

static void cb_control_plugin_button_4(Fl_Widget*, void*)//TEST
{
	xinei->start_plugin(4);
}

static void cb_control_plugin_button_5(Fl_Widget*, void*)//VCD
{
  xinei->start_plugin(5);
}

static void cb_control_plugin_button_6(Fl_Widget*, void*)//VCD
{
  xinei->start_plugin(6);
}

Fl_Box *control_playing=(Fl_Box *)0;

Fl_Slider *control_progress_bar=(Fl_Slider *)0;

static void cb_control_progress_bar(Fl_Widget*, void*) 
{
	if(xinei->status() > 0)
   { 
	xinei->set_position((int)control_progress_bar->value());

	control_progress_bar->redraw();
   }
}

static void cb_control_file_button(Fl_Button*, void*) 
{
  if( file_browser_window->visible() )
	file_browser_window->hide();
  else
	file_browser_window->show();
}

static void cb_control_play_list_button(Fl_Button*, void*) 
{
	if( gui_playlist_window->visible() )
   {
	gui_playlist_window->hide();
   }
	else
   {
	gui_playlist_window->show();
   }
}

static void cb_control_stream_info_button(Fl_Button*, void*) 
{
	xinei->osd_stream_infos();
}


Fl_Browser *gui_file_browser=(Fl_Browser *)0;

static void cb_gui_file_browser(Fl_Browser*, void*) 
{
	const char *cs = gui_file_browser->text(gui_file_browser->value());

	if(cs)
	 gui_select_file(cs);
}

Fl_File_Input *gui_filename_input=(Fl_File_Input *)0;

static void cb_gui_filename_input(Fl_File_Input*, void*) 
{
	const char *cs = gui_filename_input->value();

	if(cs)
	 gui_select_file(cs);
}

Fl_Check_Button *gui_file_filter=(Fl_Check_Button *)0;

static void cb_gui_file_filter(Fl_Check_Button*, void*) 
{
	gui_load_dir();
}

Fl_Check_Button *gui_file_hidden=(Fl_Check_Button *)0;

static void cb_gui_file_hidden(Fl_Check_Button*, void*) 
{
	gui_load_dir();
}

static void cb_gui_file_exit_button(Fl_Button*, void*) 
{
	file_browser_window->hide();
}

static void cb_gui_file_playlist_button(Fl_Button*, void*) 
{
	gui_playlist_window->show();

	playlist_add_files();
}


static void cb_gui_playlist_browser(Fl_Browser*, void*) 
{
	const char *cs;
	int item;

	item = gui_playlist_browser->value();
	cs = gui_playlist_browser->text(item);

	if(cs)
   {
	current_item = item;

	xinei->open(cs);

	xinei->play();
   }
}

Fl_Button *gui_playlist_plugin_button_0=(Fl_Button *)0;

static void cb_gui_playlist_plugin_button_0(Fl_Button*, void*) 
{
	playlist_add_plugin(0);
}

Fl_Button *gui_playlist_plugin_button_1=(Fl_Button *)0;

static void cb_gui_playlist_plugin_button_1(Fl_Button*, void*) 
{
	playlist_add_plugin(1);
}

Fl_Button *gui_playlist_plugin_button_2=(Fl_Button *)0;

static void cb_gui_playlist_plugin_button_2(Fl_Button*, void*) 
{
	playlist_add_plugin(2);
}

Fl_Button *gui_playlist_plugin_button_3=(Fl_Button *)0;

static void cb_gui_playlist_plugin_button_3(Fl_Button*, void*) 
{
	playlist_add_plugin(3);
}

Fl_Button *gui_playlist_plugin_button_4=(Fl_Button *)0;

static void cb_gui_playlist_plugin_button_4(Fl_Button*, void*) 
{
	playlist_add_plugin(4);
}

Fl_Button *gui_playlist_plugin_button_5=(Fl_Button *)0;

static void cb_gui_playlist_plugin_button_5(Fl_Button*, void*) 
{
	playlist_add_plugin(5);
}

Fl_Button *gui_playlist_plugin_button_6=(Fl_Button *)0;

static void cb_gui_playlist_plugin_button_6(Fl_Button*, void*) 
{
	playlist_add_plugin(6);
}

static void cb_gui_playlist_file_button(Fl_Button*, void*) 
{
	if( file_browser_window->visible() )
   {
	file_browser_window->hide();
   }
	else
   {
	file_browser_window->show();
   }
}

static void cb_gui_playlist_ok_button(Fl_Button*, void*) 
{
	gui_playlist_window->hide();
}

static void cb_gui_playlist_move_down_button(Fl_Button*, void*) 
{
	playlist_move_down();
}

static void cb_gui_playlist_move_up_button(Fl_Button*, void*) 
{
	playlist_move_up();
}

static void cb_gui_playlist_remove_button(Fl_Button*, void*) 
{
	playlist_remove_selected();
}

static void cb_gui_playlist_clear_button(Fl_Button*, void*) 
{
	gui_playlist_browser->clear();
}

static void control_exit_button_cb(Fl_Widget *wid, void *v)
{
	Main_exit_program();
}

static void control_volume_cb(Fl_Widget *wid, void* v)
{
	xinei->set_volume(gui_volume_knob->value());
}

static void control_mute_cb(Fl_Widget *wid, void *v)
{
	Fl_Button *b = (Fl_Button*)wid;

	xinei->toggle_mute(b->value());
}


#ifdef INFO_ONLY
/*------------------------------------------------
see: xine_iface_gui.h:

class Canvas : public Fl_Box
{

public:
	Canvas(int X, int Y, int W, int H, const char *l)
	: Fl_Box(X,Y,W,H,l)
   {

   }
	virtual int handle(int);
};
-----------------------------------------------*/
#endif //INFO_ONLY

Canvas *canvas = NULL;

int Canvas::handle(int e)
{
	if( !Fl::event_inside(x(),y(),w(),h())) return 0;

	int ex = Fl::event_x() - x(); int ey = Fl::event_y() - y();
	int ek;

	switch(e)
   {
	case FL_LEAVE:
		return 1;

	case FL_ENTER: case FL_MOVE:
		xinei->send_mouse_event(ex, ey, 0);

		return 1;

	case FL_PUSH:
		if(Fl::event_button1())
	   {
		xinei->send_mouse_event(ex, ey, 1);

		return 1;
	   }

	case FL_KEYUP:
		if(Fl::event_state() & FL_CTRL) break;
		ek = Fl::event_key();

		if(ek == FL_Up)
	   {
		xinei->nav_up();

		return 1;
	   }
		if(ek == FL_Down)
	   {
		xinei->nav_down();

		return 1;
	   }
		if(ek == FL_Left)
	   {
		xinei->nav_left();

		return 1;
	   }
		if(ek == FL_Right)
	   {
		xinei->nav_right();

		return 1;
	   }
		if(ek == FL_Enter)
	   {
		xinei->nav_select();

		return 1;
	   }

	default:
		break;
	
   }//switch(e)

	return Fl_Box::handle(e);

}//Canvas::handle()

static void show_control_cb(Fl_Widget *wid, void *v)
{
	control_window->show();
}

Fl_Menu_Item popup_items[] =
{
 {"EXIT",  0, &control_exit_button_cb,  NULL, FL_MENU_DIVIDER, 0, 4, 15, FL_YELLOW},

 {"Show Control Window",  0, &show_control_cb,  NULL, FL_NORMAL_LABEL, 0, 4, 15, FL_WHITE},
 {NULL, 0, NULL, NULL, 0, 0, 0, 0, 0}
};

static void popup_create(int x, int y)
{
    Fl_Menu_Button *popup;

    popup = new Fl_Menu_Button(x, y, video_window->w(), video_window->h());
    popup->type(Fl_Menu_Button::POPUP3);
    popup->menu(popup_items);
}

static void video_window_exit_cb(Fl_Widget *wid, void *v)
{
	Main_exit_program();
}

void gui_init()
{
//---------
  {
	int w = 666; int h = 500;

	video_window = new Fl_Window(w, h, "flxine video"); 
	video_window->box(FL_FLAT_BOX);
	video_window->color(FL_BLACK);

	canvas = new Canvas(0, 0, w, h);
    canvas->box(FL_FLAT_BOX);
    canvas->color(FL_BLACK);
	Fl_Group::current()->resizable(canvas);


	Fl::visual(FL_RGB);

	popup_create(0, 0);

	video_window->callback(video_window_exit_cb);
//	video_window->resizable(canvas);
    video_window->end();
  }
//---------
  { 
	config_window = 
		new Fl_Window(465, 350, "flxine configuration");

    { Fl_Tabs* o =
		new Fl_Tabs(0, 0, 475, 366, "flxine configuration");
      o->box(FL_PLASTIC_UP_BOX);
      o->color(FL_BLACK);
      o->selection_color(2);
      { 
		Fl_Group *ag = new Fl_Group(0, 19, 468, 341, "Audio");
        ag->color(29);
        { Fl_Choice* o = gui_audio_driver_choice = 
			new Fl_Choice(135, 54, 205, BUTTON_H, "Driver:");
          o->down_box(FL_BORDER_BOX);
          o->callback((Fl_Callback*)cb_gui_audio_driver_choice);
        }
        { Fl_Group* o = gui_audio_surround_group = 
			new Fl_Group(150, 194, 130, 115, "Surround Options");
          o->box(FL_PLASTIC_UP_FRAME);
          o->color(29);
          o->align(FL_ALIGN_TOP|FL_ALIGN_INSIDE);
          o->hide();
          o->deactivate();
          gui_audio_4speakers = 
			new Fl_Light_Button(160, 224, 110, 20, "4 Speaker");
          gui_audio_5speakers = 
			new Fl_Light_Button(160, 249, 110, 20, "5 Speaker");
          gui_audio_5_1speakers = 
			new Fl_Light_Button(160, 274, 110, 20, "5.1 Speaker");
          o->end();
        }
        ag->end();
      }
      { Fl_Group* o = gui_vid_config =
			new Fl_Group(0, 25, 472, 330, "Video");
        o->color(29);
        o->callback(cb_gui_vid_config);
        o->hide();
        { Fl_Choice* o = gui_vid_driver_choice = 
			new Fl_Choice(110, 45, 205, 25, "Driver:");
          o->down_box(FL_BORDER_BOX);
          o->callback((Fl_Callback*)cb_gui_vid_driver_choice);
        }
        { Fl_Choice* o = gui_vid_deinterlace = 
			new Fl_Choice(145, 85, 170, 25, "Deinterlace:");
          o->down_box(FL_BORDER_BOX);
          o->callback((Fl_Callback*)cb_gui_vid_deinterlace);
          o->hide();
        }
        o->end();
      }
      { Fl_Group* o =
			new Fl_Group(0, 25, 475, 334, "Post Plugins");
        o->selection_color(50);
        o->hide();
        { Fl_Choice* o = gui_vis_plugin_choice = 
			new Fl_Choice(180, 55, 120, 25, "Visualization Plugin:");
          o->tooltip("Choose the animation display if no video"
			" is present in the stream.");
          o->down_box(FL_BORDER_BOX);
          o->callback((Fl_Callback*)cb_gui_vis_plugin_choice);
        }
        { Fl_Round_Button* o = gui_vis_plugin_enable = 
			new Fl_Round_Button(180, 85, 25, 25, "Show visualiztion?");
          o->tooltip("This will display animation to the audio"
			" if no video is present in the stream.");
          o->down_box(FL_ROUND_DOWN_BOX);
          o->align(FL_ALIGN_LEFT);
        }
        o->end();
      }
      o->end();
    }
    { Fl_Button* o = gui_config_ok = 
			new Fl_Button(105, 320, 75, BUTTON_H, "OK");
      o->box(FL_PLASTIC_UP_BOX);
      o->callback((Fl_Callback*)cb_gui_config_ok);
    }
    { Fl_Button* o = new Fl_Button(255, 320, 70, BUTTON_H, "Cancel");
      o->box(FL_PLASTIC_UP_BOX);
      o->color(64);
      o->callback((Fl_Callback*)cb_Cancel);
    }
    { Fl_Button* o = gui_config_apply = 
			new Fl_Button(180, 320, 75, BUTTON_H, "Apply");
      o->box(FL_PLASTIC_UP_BOX);
      o->callback((Fl_Callback*)cb_gui_config_apply);
    }
    config_window->end();
  }
//---------
  { 
	control_window = new Fl_Window(520, GUI_WINDOW_H, "flxine control");
	control_window->box(FL_FLAT_BOX);
    control_window->color(FL_GRAY0);

	int x = DX; int y = DY; int top_y; int center_x, size;

    { 
#ifdef INFORMATION_ONLY
#define FL_VERT_SLIDER      0
#define FL_HOR_SLIDER       1
#define FL_VERT_FILL_SLIDER 2
#define FL_HOR_FILL_SLIDER  3
#define FL_VERT_NICE_SLIDER 4
#define FL_HOR_NICE_SLIDER  5

#endif
	Fl_Slider* o = control_progress_bar = 
		new Fl_Slider(x, y, 420, SLIDER_H);
#ifdef WANT_NICE_SLIDER
	  fl_color(218,165,32);
      o->type(FL_HOR_NICE_SLIDER);
	  o->selection_color(fl_color());
#else
	  o->type(FL_HOR_FILL_SLIDER);
	  o->selection_color(FL_DARK2);
#endif
      o->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
      o->minimum(0);
      o->maximum(SLIDER_MAX);
	  o->step(SLIDER_STEP);
      o->callback(cb_control_progress_bar);
	  o->clear_visible_focus();
    }
	y += control_progress_bar->h() + DY;

    { Fl_Box* o = control_playing = 
		new Fl_Box(x, y, 420, BUTTON_H, "No Title");
      o->box(FL_PLASTIC_DOWN_BOX);
      o->color(FL_BLACK);
      o->labeltype(FL_EMBOSSED_LABEL);
      o->labelfont(FL_HELVETICA_BOLD);
      o->labelsize(14);
    }
	y += control_playing->h() + DY;

    {
	 Fl_Group *g = new Fl_Group(98, y, 232, BUTTON_H);

      { Fl_Button* o =
            new Fl_Button(100, y, 30, BUTTON_H, "@|<");
        o->box(FL_PLASTIC_UP_BOX);
        o->down_box(FL_PLASTIC_DOWN_BOX);
        o->color(11);
        o->tooltip("Prev Chapter or Track");
        o->callback((Fl_Callback*)cb_control_prev_button);
      }
      { Fl_Button* o =
            new Fl_Button(130, y, 30, BUTTON_H, "@<<");
        o->box(FL_PLASTIC_UP_BOX);
        o->down_box(FL_PLASTIC_DOWN_BOX);
        o->color(11);
        o->tooltip("Slow Forward");
        o->callback((Fl_Callback*)cb_control_slower_button);
      }

      { Fl_Button* o =
			new Fl_Button(160, y, 40, BUTTON_H, "@> ||");
        o->box(FL_PLASTIC_UP_BOX);
        o->down_box(FL_PLASTIC_DOWN_BOX);
        o->color(2);
        o->labelfont(FL_HELVETICA_BOLD);
		o->tooltip("Play or Pause");
        o->callback((Fl_Callback*)cb_control_play_button);
        o->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
      }
      { Fl_Button* o =
			new Fl_Button(200, y, 40, BUTTON_H, "@square");
        o->box(FL_PLASTIC_UP_BOX);
        o->down_box(FL_PLASTIC_DOWN_BOX);
        o->color(9);
		o->tooltip("Stop");
        o->callback((Fl_Callback*)cb_control_stop_button);
      }
      { Fl_Button* o =
            new Fl_Button(240, y, 30, BUTTON_H, "@8|>");
        o->box(FL_PLASTIC_UP_BOX);
        o->down_box(FL_PLASTIC_DOWN_BOX);
        o->color(4);
        o->tooltip("Eject");
        o->callback((Fl_Callback*)cb_control_eject_button);
      }
      { Fl_Button* o =
            new Fl_Button(270, y, 30, BUTTON_H, "@>>");
        o->box(FL_PLASTIC_UP_BOX);
        o->down_box(FL_PLASTIC_DOWN_BOX);
        o->color(11);
        o->tooltip("Fast Forward");
        o->callback((Fl_Callback*)cb_control_faster_button);
      }
      { Fl_Button* o =
			new Fl_Button(300, y, 30, BUTTON_H, "@>|");
        o->box(FL_PLASTIC_UP_BOX);
        o->down_box(FL_PLASTIC_DOWN_BOX);
        o->color(11);
		o->tooltip("Next Chapter or Track");
        o->callback((Fl_Callback*)cb_control_next_button);
      }

      g->end();
	y += g->h() + DY;
    }
	top_y = y;
    { 
	  size = (BUTTON_H * 3) + 6;
	  x = control_window->w() - DX - size;
	  center_x = x + size/2;
	  y = DY;

	  Fl_Group *navi = new Fl_Group(x, y, size, size);
      navi->tooltip("Navigation controls");
      navi->box(FL_DIAMOND_DOWN_BOX);
      navi->color(27);

	  x += 3; y += 3;
      { 
		int bx = x; int by = y + BUTTON_H;
		Fl_Button *o =
			new Fl_Button(bx, by, BUTTON_H, BUTTON_H, "@<");
        o->tooltip("Left Navigation");
        o->box(FL_PLASTIC_UP_BOX);
        o->down_box(FL_PLASTIC_DOWN_BOX);
        o->shortcut(0x34);
        o->color(12);
        o->callback(cb_navi_left_button);
      }
      { 
		int bx = x + BUTTON_H; int by = y + BUTTON_H;
		Fl_Button *o =
			new Fl_Button(bx, by, BUTTON_H, BUTTON_H, "@circle");
        o->tooltip("Select Menu Item");
        o->box(FL_PLASTIC_UP_BOX);
        o->down_box(FL_PLASTIC_DOWN_BOX);
        o->shortcut(0x35);
        o->color(86);
        o->callback(cb_navi_select_button);
      }
      { 
		int bx = x + BUTTON_H + BUTTON_H; int by = y + BUTTON_H;
		Fl_Button *o =
			new Fl_Button(bx, by, BUTTON_H, BUTTON_H, "@>");
        o->tooltip("Right Navigation");
        o->box(FL_PLASTIC_UP_BOX);
        o->down_box(FL_PLASTIC_DOWN_BOX);
        o->shortcut(0x36);
        o->color(12);
        o->callback(cb_navi_right_button);
      }
      { 
		int bx = x + BUTTON_H; int by = y + BUTTON_H + BUTTON_H;
		Fl_Button *o =
			new Fl_Button(bx, by, BUTTON_H, BUTTON_H, "@2>");
        o->tooltip("Down Navigation");
        o->box(FL_PLASTIC_UP_BOX);
        o->down_box(FL_PLASTIC_DOWN_BOX);
        o->shortcut(0x32);
        o->color(12);
        o->callback(cb_navi_down_button);
      }
      { 
		int bx = x + BUTTON_H; int by = y;
		Fl_Button *o =
			new Fl_Button(bx, by, BUTTON_H, BUTTON_H, "@8>");
        o->tooltip("Up Navigation");
        o->box(FL_PLASTIC_UP_BOX);
        o->down_box(FL_PLASTIC_DOWN_BOX);
        o->shortcut(0x38);
        o->color(12);
        o->callback(cb_navi_up_button);
      }
      { 
		int bx = x; int by = y + BUTTON_H + BUTTON_H;
		Fl_Button *o =
			new Fl_Button(bx, by, BUTTON_H, BUTTON_H, "@menu");
        o->tooltip("Main Menu");
        o->box(FL_PLASTIC_UP_BOX);
        o->down_box(FL_PLASTIC_DOWN_BOX);
        o->shortcut(0x31);
        o->color(172);
        o->callback(cb_navi_menu_button);
        o->align(FL_ALIGN_CLIP);
      }
     navi->end();
	y = navi->y() + navi->h() + DY;
    }
    {
	 int vsize = 50;
	x = center_x - vsize/2;

    Fl_Line_Dial *o  = gui_volume_knob =
		new Fl_Line_Dial(x, y, vsize, vsize, "Volume");
    o->labelsize(12);
	o->labelcolor(FL_WHITE);
    o->color(10);
    o->selection_color(1);
	o->minimum(0.);
	o->maximum(100.);
    o->value(50.);
    o->callback(control_volume_cb);
    o->angle1(5); o->angle2(355);
	}
	x = center_x - size/2;
	y = GUI_WINDOW_H - DY - BUTTON_H;

	Fl_Light_Button *gui_volume_mute_button =
		new Fl_Light_Button(x+2, y, size-4, BUTTON_H, "MUTE");
	gui_volume_mute_button->align(Fl_Align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE));
	gui_volume_mute_button->callback(control_mute_cb);
	gui_volume_mute_button->box(FL_PLASTIC_UP_BOX);
	gui_volume_mute_button->labelfont(FL_HELVETICA_BOLD);
	y = top_y;

    { 
	 Fl_Group *pg = new Fl_Group(DX, y, 425, BUTTON_H);

      { Fl_Button* o = control_plugin_button_0 =
			new Fl_Button(365, y, 60, BUTTON_H);
        o->box(FL_PLASTIC_UP_BOX);
        o->down_box(FL_PLASTIC_DOWN_BOX);
        o->color(223);
        o->labelfont(FL_HELVETICA_BOLD);
        o->callback((Fl_Callback*)cb_control_plugin_button_0);//CD
      }
      { Fl_Button* o = control_plugin_button_1 =
			new Fl_Button(305, y, 60, BUTTON_H);
        o->box(FL_PLASTIC_UP_BOX);
        o->down_box(FL_PLASTIC_DOWN_BOX);
        o->color(231);
        o->labelfont(FL_HELVETICA_BOLD);
        o->callback(cb_control_plugin_button_1);//DVB
      }
      { Fl_Button* o = control_plugin_button_2 =
			new Fl_Button(245, y, 60, BUTTON_H);
        o->box(FL_PLASTIC_UP_BOX);
        o->down_box(FL_PLASTIC_DOWN_BOX);
        o->color(231);
        o->labelfont(FL_HELVETICA_BOLD);
        o->callback(cb_control_plugin_button_2);//DVB
      }
      { Fl_Button* o = control_plugin_button_3 =
			new Fl_Button(185, y, 60, BUTTON_H);
        o->box(FL_PLASTIC_UP_BOX);
        o->down_box(FL_PLASTIC_DOWN_BOX);
        o->color(231);
        o->labelfont(FL_HELVETICA_BOLD);
        o->callback(cb_control_plugin_button_3);//DVD
      }
      { Fl_Button* o = control_plugin_button_4 =
			new Fl_Button(125, y, 60, BUTTON_H);
        o->box(FL_PLASTIC_UP_BOX);
        o->down_box(FL_PLASTIC_DOWN_BOX);
        o->color(231);
        o->labelfont(FL_HELVETICA_BOLD);
        o->callback(cb_control_plugin_button_4);//TEST
      }
      { Fl_Button* o = control_plugin_button_5 =
			new Fl_Button(65, y, 60, BUTTON_H);
        o->box(FL_PLASTIC_UP_BOX);
        o->down_box(FL_PLASTIC_DOWN_BOX);
        o->color(231);
        o->labelfont(FL_HELVETICA_BOLD);
        o->callback(cb_control_plugin_button_5);//VCD
      }

      { Fl_Button* o = control_plugin_button_6 =
			new Fl_Button(DX, y, 60, BUTTON_H);
        o->box(FL_PLASTIC_UP_BOX);
        o->down_box(FL_PLASTIC_DOWN_BOX);
        o->color(231);
        o->labelfont(FL_HELVETICA_BOLD);
        o->callback(cb_control_plugin_button_6);//VCD
      }

     pg->end();
	y += pg->h() + DY;
    }
    { Fl_Button* o =
		new Fl_Button(DX, y, 90, BUTTON_H, "FILE");
      o->box(FL_PLASTIC_UP_BOX);
      o->labelfont(FL_HELVETICA_BOLD);
      o->callback((Fl_Callback*)cb_control_file_button);
    }
    { Fl_Button* o =
        new Fl_Button(335, y, 90, BUTTON_H, "CONFIG");
      o->tooltip("Open flxine Configuration Dialog");
      o->box(FL_PLASTIC_UP_BOX);
      o->down_box(FL_PLASTIC_DOWN_BOX);
      o->color(128);
      o->labelfont(FL_HELVETICA_BOLD);
      o->callback((Fl_Callback*)cb_control_config_button);
	y += o->h() + DY;
    }


    { Fl_Button* o =
		new Fl_Button(DX, y, 90, BUTTON_H, "PLAYLIST");
      o->box(FL_PLASTIC_UP_BOX);
      o->labelfont(FL_HELVETICA_BOLD);
      o->callback((Fl_Callback*)cb_control_play_list_button);
    }

    { Fl_Button* o =
		new Fl_Button(335, y, 90, BUTTON_H, "OSD-INFO");
      o->tooltip("Display stream information over the video");
      o->box(FL_PLASTIC_UP_BOX);
      o->down_box(FL_PLASTIC_DOWN_BOX);
      o->shortcut(0x69);
      o->color(128);
      o->labelfont(FL_HELVETICA_BOLD);
      o->callback((Fl_Callback*)cb_control_stream_info_button);
	y += o->h() + DY;
    }
    {
        Fl_Button* o =
            new Fl_Button(DX, y, 90, BUTTON_H, "EXIT");
        o->box(FL_PLASTIC_UP_BOX);
        o->color(FL_YELLOW);
        o->labelfont(FL_HELVETICA_BOLD);
        o->callback(control_exit_button_cb);
	x = o->x() + o->w() + DX;
    }

    Clock = new Fl_Box(x, y, 72, BUTTON_H);
	Clock->box(FL_NO_BOX);
    Clock->label("00:00:00");
	Clock->labelcolor(FL_WHITE);
	Clock->labelfont(FL_HELVETICA_BOLD);

	size = 121; x += Clock->w() + DX;
    {
	int gx = x;
    control_language_group = new Fl_Group(x, y, size, BUTTON_H);
	control_language_group->box(FL_PLASTIC_UP_BOX);
    control_language_group->begin();

    Fl_Box *lbox = new Fl_Box(x, y,72,BUTTON_H,"LANGUAGE:");
    lbox->labelsize(14);
    lbox->labelfont(FL_COURIER_BOLD);

    x += 72;
    Fl_Button *up = new Fl_Button(x, y,15,LANG_BUT_H, "@8>");
    up->callback(lang_up_cb);

    Fl_Button *down = new Fl_Button(x, y+1+LANG_BUT_H,15,LANG_BUT_H, "@2>");
    down->callback(lang_down_cb);

    x += 16;
	lang = -1;
    control_language_box = new Fl_Box(x, y,30,BUTTON_H, "auto");
    control_language_box->labelsize(12);
    control_language_box->labelfont(FL_COURIER_BOLD);
    control_language_box->align(FL_ALIGN_INSIDE|FL_ALIGN_LEFT);

    control_language_group->end();
	control_language_group->deactivate();
	x = gx;
    }
	x += size + DX;
    {
    control_subtitle_group = new Fl_Group(x, y, size,BUTTON_H);
	control_subtitle_group->box(FL_PLASTIC_UP_BOX);
    control_subtitle_group->begin();

    Fl_Box *lbox = new Fl_Box(x, y,72,BUTTON_H,"SUBTITLE:");
    lbox->labelsize(14);
    lbox->labelfont(FL_COURIER_BOLD);

    x += 72;
    Fl_Button *up = new Fl_Button(x, y,15,LANG_BUT_H, "@8>");
    up->callback(sub_up_cb);

    Fl_Button *down = new Fl_Button(x, y+1+LANG_BUT_H,15,LANG_BUT_H, "@2>");
    down->callback(sub_down_cb);

    x += 16;
	sub = -1;
    control_subtitle_box = new Fl_Box(x, y,30,BUTTON_H, "none");
    control_subtitle_box->labelsize(12);
    control_subtitle_box->labelfont(FL_COURIER_BOLD);
    control_subtitle_box->align(FL_ALIGN_INSIDE|FL_ALIGN_LEFT);

    control_subtitle_group->end();
	control_subtitle_group->deactivate();
    }
	
    control_window->end();
  }
//---------
  { Fl_Window* o = file_browser_window = 
		new Fl_Window(530, 480, "flxine file browser");
    o->box(FL_EMBOSSED_BOX);
    o->color(FL_BLACK);
	int x;

    { Fl_Browser* o = gui_file_browser = new Fl_Browser(2,2,526,403);
      o->type(3);
      o->color(97);
      o->labelfont(FL_HELVETICA_BOLD);
      o->textfont(1);
      o->textcolor(26);
      o->callback((Fl_Callback*)cb_gui_file_browser);
      o->when(FL_WHEN_ENTER_KEY_ALWAYS);
    }
    { Fl_File_Input* o = gui_filename_input = 
		new Fl_File_Input(2,405,526,35);
      o->color(138);
      o->labelcolor(31);
      o->textcolor(23);
      o->callback((Fl_Callback*)cb_gui_filename_input);
      o->value(main_dir);
    }
	x = DX;
    { Fl_Button* o =
		new Fl_Button(x,445, 80, 25, "EXIT");
      o->box(FL_PLASTIC_UP_BOX);
      o->labeltype(FL_ENGRAVED_LABEL);
      o->labelfont(FL_HELVETICA_BOLD);
      o->callback((Fl_Callback*)cb_gui_file_exit_button);
    }
	x += 85;
    { Fl_Button* o =
		new Fl_Button(x,445, 80, 25, "@+ Playlist");
      o->box(FL_PLASTIC_UP_BOX);
      o->labeltype(FL_ENGRAVED_LABEL);
      o->labelfont(FL_HELVETICA_BOLD);
      o->callback((Fl_Callback*)cb_gui_file_playlist_button);
    }
	x += 80 + 120;
    { Fl_Check_Button* o = gui_file_filter =
        new Fl_Check_Button(x, 445, 25, 25, "Filter Files");
      o->down_box(FL_DOWN_BOX);
      o->labelfont(FL_HELVETICA_BOLD);
      o->labelcolor(7);
      o->callback((Fl_Callback*)cb_gui_file_filter);
      o->align(FL_ALIGN_LEFT);
    }
	x = gui_file_filter->x() + gui_file_filter->w() + 150;
    { Fl_Check_Button* o = gui_file_hidden =
        new Fl_Check_Button(x, 445, 25, 25, "Show Hidden");
      o->down_box(FL_DOWN_BOX);
      o->labelfont(FL_HELVETICA_BOLD);
      o->labelcolor(7);
      o->callback((Fl_Callback*)cb_gui_file_hidden);
      o->align(FL_ALIGN_LEFT);
    }
    gui_load_dir();
    o->end();
	o->resizable(0);
  }
//---------
  { gui_playlist_window = 
		new Fl_Window(510, 480, "flxine playlist browser");

    gui_playlist_window->box(FL_EMBOSSED_BOX);
    gui_playlist_window->color(FL_BLACK);

	int y = DY; int x = 445; int h;
    { Fl_Browser* o = gui_playlist_browser = 
		new Fl_Browser(DX, DY, 435, 435);
      o->type(3);
      o->color(97);
      o->labelfont(FL_HELVETICA_BOLD);
      o->textfont(1);
      o->textcolor(26);
      o->callback((Fl_Callback*)cb_gui_playlist_browser);
      o->when(FL_WHEN_ENTER_KEY_ALWAYS);
    }
    { Fl_Group* gr = 
		new Fl_Group(x, y, 60, 8 * (BUTTON_H + DY) + DY );

		y += DY;
      { Fl_Button* o = gui_playlist_plugin_button_0 = 
			new Fl_Button(x, y, 60, BUTTON_H);
        o->box(FL_PLASTIC_UP_BOX);
        o->down_box(FL_PLASTIC_DOWN_BOX);
        o->color(231);
        o->labelfont(FL_HELVETICA_BOLD);
        o->callback((Fl_Callback*)cb_gui_playlist_plugin_button_0);//CD
        o->align(FL_ALIGN_CLIP);
      }
		y += BUTTON_H + DY;
      { Fl_Button* o = gui_playlist_plugin_button_1 = 
			new Fl_Button(x, y, 60, BUTTON_H);
        o->box(FL_PLASTIC_UP_BOX);
        o->down_box(FL_PLASTIC_DOWN_BOX);
        o->color(231);
        o->labelfont(FL_HELVETICA_BOLD);
        o->callback((Fl_Callback*)cb_gui_playlist_plugin_button_1);//DVB
        o->align(FL_ALIGN_CLIP);
      }
		y += BUTTON_H + DY;
      { Fl_Button* o = gui_playlist_plugin_button_2 = 
			new Fl_Button(x, y, 60, BUTTON_H);
        o->box(FL_PLASTIC_UP_BOX);
        o->down_box(FL_PLASTIC_DOWN_BOX);
        o->color(231);
        o->labelfont(FL_HELVETICA_BOLD);
        o->callback((Fl_Callback*)cb_gui_playlist_plugin_button_2);//DVB
        o->align(FL_ALIGN_CLIP);
      }
		y += BUTTON_H + DY;
      { Fl_Button* o = gui_playlist_plugin_button_3 = 
			new Fl_Button(x, y, 60, BUTTON_H);
        o->box(FL_PLASTIC_UP_BOX);
        o->down_box(FL_PLASTIC_DOWN_BOX);
        o->color(231);
        o->labelfont(FL_HELVETICA_BOLD);
        o->callback((Fl_Callback*)cb_gui_playlist_plugin_button_3);//DVD
        o->align(FL_ALIGN_CLIP);
      }
		y += BUTTON_H + DY;
      { Fl_Button* o = gui_playlist_plugin_button_4 = 
			new Fl_Button(x, y, 60, BUTTON_H);
        o->box(FL_PLASTIC_UP_BOX);
        o->down_box(FL_PLASTIC_DOWN_BOX);
        o->color(231);
        o->labelfont(FL_HELVETICA_BOLD);
        o->callback((Fl_Callback*)cb_gui_playlist_plugin_button_4);//TEST
        o->align(FL_ALIGN_CLIP);
      }
		y += BUTTON_H + DY;
      { Fl_Button* o = gui_playlist_plugin_button_5 = 
			new Fl_Button(x, y, 60, BUTTON_H);
        o->box(FL_PLASTIC_UP_BOX);
        o->down_box(FL_PLASTIC_DOWN_BOX);
        o->color(231);
        o->labelfont(FL_HELVETICA_BOLD);
        o->callback((Fl_Callback*)cb_gui_playlist_plugin_button_5);//VCD
        o->align(FL_ALIGN_CLIP);
      }
		y += BUTTON_H + DY;
      { Fl_Button* o = gui_playlist_plugin_button_6 = 
			new Fl_Button(x, y, 60, BUTTON_H);
        o->box(FL_PLASTIC_UP_BOX);
        o->down_box(FL_PLASTIC_DOWN_BOX);
        o->color(231);
        o->labelfont(FL_HELVETICA_BOLD);
        o->callback((Fl_Callback*)cb_gui_playlist_plugin_button_6);//VCD
        o->align(FL_ALIGN_CLIP);
      }
		y += BUTTON_H + DY;
      { Fl_Button* o =
			new Fl_Button(x, y, 60, BUTTON_H, "FILE");
        o->box(FL_PLASTIC_UP_BOX);
        o->labeltype(FL_ENGRAVED_LABEL);
        o->labelfont(FL_HELVETICA_BOLD);
        o->callback((Fl_Callback*)cb_gui_playlist_file_button);
        o->align(FL_ALIGN_CLIP);
      }
      gr->end();
    }
		y = 445; h = BUTTON_H + DY;
    { Fl_Group* bottom_items = 
		new Fl_Group(DX, y, gui_playlist_window->w() - 10, h);

      { Fl_Button* o =
			new Fl_Button(DX, y, 75, h, "OK");
        o->box(FL_PLASTIC_UP_BOX);
        o->labeltype(FL_ENGRAVED_LABEL);
        o->labelfont(FL_HELVETICA_BOLD);
        o->callback((Fl_Callback*)cb_gui_playlist_ok_button);
        o->align(FL_ALIGN_CLIP);
      }
      { Fl_Button* o =
			new Fl_Button(125, y, 80, h, "@8 MOVE");
        o->box(FL_PLASTIC_UP_BOX);
        o->labeltype(FL_ENGRAVED_LABEL);
        o->labelfont(FL_HELVETICA_BOLD);
        o->callback((Fl_Callback*)cb_gui_playlist_move_up_button);
        o->align(FL_ALIGN_CLIP);
      }
      { Fl_Button* o =
            new Fl_Button(210, y, 80, h, "@2 MOVE");
        o->box(FL_PLASTIC_UP_BOX);
        o->labeltype(FL_ENGRAVED_LABEL);
        o->labelfont(FL_HELVETICA_BOLD);
        o->callback((Fl_Callback*)cb_gui_playlist_move_down_button);
        o->align(FL_ALIGN_CLIP);
      }
      { Fl_Button* o =
			new Fl_Button(295, y, 80, h, "REMOVE");
        o->box(FL_PLASTIC_UP_BOX);
        o->labeltype(FL_ENGRAVED_LABEL);
        o->labelfont(FL_HELVETICA_BOLD);
        o->callback((Fl_Callback*)cb_gui_playlist_remove_button);
        o->align(FL_ALIGN_CLIP);
      }
		x = bottom_items->x() + bottom_items->w() - 55;
      { Fl_Button* o =
			new Fl_Button(x, y, 55, h, "CLEAR");
        o->box(FL_PLASTIC_UP_BOX);
        o->color(80);
        o->labeltype(FL_ENGRAVED_LABEL);
        o->labelfont(FL_HELVETICA_BOLD);
        o->callback((Fl_Callback*)cb_gui_playlist_clear_button);
        o->align(FL_ALIGN_CLIP);
      }
     bottom_items->end();
    }
    gui_load_dir();
    gui_playlist_window->end();
    gui_playlist_window->resizable(gui_playlist_window);
  }
}//init_gui()

