#ifndef _STRUCT_XINE_INFO_
#define _STRUCT_XINE_INFO_

#include <xine.h>

#define MAX_VIDEO_ATTR 8
#define CD_VIDEO_WIDTH  300 //512
#define CD_VIDEO_HEIGHT 200 //384

#define TEST_VIDEO_WIDTH  512
#define TEST_VIDEO_HEIGHT 384

struct xine_info
{
	xine_t *xine;
	char *mrl;
	const char *vis_name;

	xine_audio_port_t *xine_audio;
	xine_video_port_t *xine_video;

	const char *audio_driver;
	const char *video_driver;

	xine_stream_t *xine_stream;      
	xine_event_queue_t *xine_event_queue;      
	xine_post_t *post_plugin;      

	int osd_enabled;	  
	int vis_enabled, vis_active;

	pthread_mutex_t start_plugin_mutex;

	pthread_t osd_timer_thread;
	pthread_mutex_t osd_mutex;

	xine_osd_t *osd_info;
	xine_osd_t *osd_status;
	xine_osd_t *osd_bar[2];

	int osd_bar_visible; 
	int osd_info_visible;
	int osd_stop;

	int osd_status_visible;
	int osd_timeout;

	x11_visual_t vis;
	double aspect_ratio;
// video_attr stores the x/y/w/h information for the vo callbacks
//
	int video_attr[MAX_VIDEO_ATTR];

	bool test_is_running;
	bool cd_is_running;
	bool osd_initialized;
	bool dvd_is_running;
};

#endif //_STRUCT_XINE_INFO_
